link for start-testcase-DMM
[csit.git] / bootstrap-verify-perf-DPDK.sh
index 1b8a885..b75caeb 100755 (executable)
@@ -1,5 +1,5 @@
 #!/bin/bash
-# Copyright (c) 2016 Cisco and/or its affiliates.
+# Copyright (c) 2018 Cisco and/or its affiliates.
 # Licensed under the Apache License, Version 2.0 (the "License");
 # you may not use this file except in compliance with the License.
 # You may obtain a copy of the License at:
@@ -12,7 +12,7 @@
 # See the License for the specific language governing permissions and
 # limitations under the License.
 
-set -x
+set -xo pipefail
 
 # Space separated list of available testbeds, described by topology files
 TOPOLOGIES="topologies/available/lf_testbed1.yaml \
@@ -20,18 +20,40 @@ TOPOLOGIES="topologies/available/lf_testbed1.yaml \
             topologies/available/lf_testbed3.yaml"
 
 SCRIPT_DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"
+export PYTHONPATH=${SCRIPT_DIR}
+export DEBIAN_FRONTEND=noninteractive
 
 # Reservation dir
 RESERVATION_DIR="/tmp/reservation_dir"
 
-PYBOT_ARGS="-W 150"
-
-ARCHIVE_ARTIFACTS=(log.html output.xml report.html output_perf_data.xml)
-
-# we will download the DPDK in the robot
+JOB_ARCHIVE_ARTIFACTS=(log.html output.xml report.html)
+LOG_ARCHIVE_ARTIFACTS=(log.html output.xml report.html)
+JOB_ARCHIVE_DIR="archive"
+LOG_ARCHIVE_DIR="$WORKSPACE/archives"
+mkdir -p ${JOB_ARCHIVE_DIR}
+mkdir -p ${LOG_ARCHIVE_DIR}
+
+# If we run this script from CSIT jobs we want to use stable version
+if [[ ${JOB_NAME} == csit-* ]] ;
+then
+    DPDK_REPO='https://fast.dpdk.org/rel/'
+    if [[ ${TEST_TAG} == *DAILY ]] || \
+       [[ ${TEST_TAG} == *WEEKLY ]];
+    then
+        echo Downloading latest DPDK packages from repo...
+        DPDK_STABLE_VER=$(wget --no-check-certificate --quiet -O - ${DPDK_REPO} | \
+            grep -v '2015' | grep -Eo 'dpdk-[^\"]+xz' | tail -1)
+    else
+        echo Downloading DPDK packages of specific version from repo...
+        DPDK_STABLE_VER='dpdk-18.05.tar.xz'
+    fi
+    wget --no-check-certificate --quiet ${DPDK_REPO}${DPDK_STABLE_VER}
+else
+    echo "Unable to identify job type based on JOB_NAME variable: ${JOB_NAME}"
+    exit 1
+fi
 
 WORKING_TOPOLOGY=""
-export PYTHONPATH=${SCRIPT_DIR}
 
 sudo apt-get -y update
 sudo apt-get -y install libpython2.7-dev python-virtualenv
@@ -73,66 +95,61 @@ function cancel_all {
 # On script exit we cancel the reservation
 trap "cancel_all ${WORKING_TOPOLOGY}" EXIT
 
+# Based on job we will identify DUT
+if [[ ${JOB_NAME} == *hc2vpp* ]] ;
+then
+    DUT="hc2vpp"
+elif [[ ${JOB_NAME} == *vpp* ]] ;
+then
+    DUT="vpp"
+elif [[ ${JOB_NAME} == *ligato* ]] ;
+then
+    DUT="kubernetes"
+elif [[ ${JOB_NAME} == *dpdk* ]] ;
+then
+    DUT="dpdk"
+else
+    echo "Unable to identify dut type based on JOB_NAME variable: ${JOB_NAME}"
+    exit 1
+fi
+
+PYBOT_ARGS="--consolewidth 120 --loglevel TRACE --variable TOPOLOGY_PATH:${WORKING_TOPOLOGY} --suite tests.${DUT}.perf"
+
 case "$TEST_TAG" in
-    # run specific performance tests based on jenkins job type variable
-    PERFTEST_LONG )
-        pybot ${PYBOT_ARGS} \
-              -L TRACE \
-              -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
-              -v DPDK_TEST:True \
-              -s "tests.dpdk.perf" \
-              --exclude SKIP_PATCH \
-              -i NDRPDRDISC \
-              tests/dpdk/
-        RETURN_STATUS=$(echo $?)
-        ;;
-    PERFTEST_SHORT )
-        pybot ${PYBOT_ARGS} \
-              -L TRACE \
-              -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
-              -v DPDK_TEST:True \
-              -s "tests.dpdk.perf" \
-              -i NDRCHK \
-              tests/dpdk/
-        RETURN_STATUS=$(echo $?)
+    # select specific performance tests based on jenkins job type variable
+    PERFTEST_MRR_DAILY )
+       TAGS=('mrrAND64bAND1t1c'
+             'mrrAND64bAND2t2c'
+             'mrrAND64bAND4t4c'
+             'mrrAND78bAND1t1c'
+             'mrrAND78bAND2t2c'
+             'mrrAND78bAND4t4c'
+             'mrrANDimixAND1t1c'
+             'mrrANDimixAND2t2c'
+             'mrrANDimixAND4t4c')
         ;;
-   PERFTEST_NIGHTLY )
-        #run all available tests
-        pybot ${PYBOT_ARGS} \
-              -L TRACE \
-              -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
-              -v DPDK_TEST:True \
-              -s "tests.dpdk.perf" \
-              tests/dpdk/
-        RETURN_STATUS=$(echo $?)
+    VERIFY-PERF-MRR )
+        TAGS=('mrrAND1t1c'
+              'mrrAND2t2c')
         ;;
     * )
-        # run full performance test suite and exit on fail
-        pybot ${PYBOT_ARGS} \
-              -L TRACE \
-              -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
-              -v DPDK_TEST:True \
-              -s "tests.dpdk.perf" \
-              tests/
-        RETURN_STATUS=$(echo $?)
+        TAGS=('perftest')
 esac
 
-# Pybot output post-processing
-echo Post-processing test data...
+# Catenate TAG selections by 'OR'
+printf -v INCLUDES " --include %s " "${TAGS[@]}"
 
-python ${SCRIPT_DIR}/resources/tools/scripts/robot_output_parser.py \
-       -i ${SCRIPT_DIR}/output.xml \
-       -o ${SCRIPT_DIR}/output_perf_data.xml
-if [ ! $? -eq 0 ]; then
-    echo "Parsing ${SCRIPT_DIR}/output.xml failed"
-fi
+# Execute the test
+pybot ${PYBOT_ARGS}${INCLUDES} tests/
+RETURN_STATUS=$(echo $?)
 
-# Archive artifacts
-mkdir archive
-for i in ${ARCHIVE_ARTIFACTS[@]}; do
-    cp $( readlink -f ${i} | tr '\n' ' ' ) archive/
+# Archive JOB artifacts in jenkins
+for i in ${JOB_ARCHIVE_ARTIFACTS[@]}; do
+    cp $( readlink -f ${i} | tr '\n' ' ' ) ${JOB_ARCHIVE_DIR}/
+done
+# Archive JOB artifacts to logs.fd.io
+for i in ${LOG_ARCHIVE_ARTIFACTS[@]}; do
+    cp $( readlink -f ${i} | tr '\n' ' ' ) ${LOG_ARCHIVE_DIR}/
 done
-
-echo Post-processing finished.
 
 exit ${RETURN_STATUS}